﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using Microsoft.VisualBasic;


namespace cs41_webio_logger
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        Socket TCP_Client;
        byte[] receiveBuffer = new byte[512];
        byte[] lastReceive = new byte[512];

        DateTime baseDate = DateTime.Parse("1.1.70 00:00:00");

        private delegate void Delegatevoid();



        private void bt_connect_Click(object sender, EventArgs e)
        {
            if (this.ed_IP.Text != "" && this.ed_Port.Text != "")
            {

                try
                {
                    IPEndPoint RemoteEP = new IPEndPoint(IPAddress.Parse(this.ed_IP.Text), int.Parse(this.ed_Port.Text));
                    this.TCP_Client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                    this.Invoke(new Delegatevoid(connectdisable));

                    this.TCP_Client.BeginConnect(RemoteEP, new AsyncCallback(callback_connect), TCP_Client);

                    this.ProgressBar1.Value = 0;
                    this.lw_receive.Items.Clear();
                }
                catch (Exception)
                {
                    this.sb_status.Text = "Error while connecting!";
                }
            }

        }
        //--------------------------------------------------------------------------------------------


        private void callback_connect(IAsyncResult ar)
        {

            try
            {

                TCP_Client.EndConnect(ar);

                this.sb_status.Text = "connected";

                this.Invoke(new Delegatevoid(connectdisable));
                TCP_Client.BeginReceive(receiveBuffer, 0, 72, SocketFlags.None, new AsyncCallback(callback_receive), TCP_Client);


                try
                {
                    byte[] cmd;
                    structs.LoggerRequest LoggerRequest = new structs.LoggerRequest();
                    LoggerRequest.Start_1 = 0;
                    LoggerRequest.Start_2 = 0;
                    LoggerRequest.StructType = 0x1E0;
                    LoggerRequest.StructLength = 20;

                    DateTime startDate = new DateTime(int.Parse(this.ed_year0.Text), int.Parse(this.ed_month0.Text), int.Parse(this.ed_day0.Text), int.Parse(this.ed_hour0.Text), int.Parse(this.ed_minute0.Text), int.Parse(this.ed_second0.Text));
                    DateTime stopDate = new DateTime(int.Parse(this.ed_year1.Text), int.Parse(this.ed_month1.Text), int.Parse(this.ed_day1.Text), int.Parse(this.ed_hour1.Text), int.Parse(this.ed_minute1.Text), int.Parse(this.ed_second1.Text));

                    LoggerRequest.StartSecs = (UInt32)(startDate.Subtract(baseDate).TotalSeconds - int.Parse(ed_utcoffset.Text) * 3600);
                    LoggerRequest.StopSecs = (UInt32)(stopDate.Subtract(baseDate).TotalSeconds - int.Parse(ed_utcoffset.Text) * 3600);

                    LoggerRequest.StartMSecs = 0;
                    LoggerRequest.StopMSecs = 0;

                    cmd = ByteConvert.ToBytes(LoggerRequest, typeof(structs.LoggerRequest));
                    this.TCP_Client.Send(cmd, cmd.Length, SocketFlags.None);

                    this.ProgressBar1.Value = 0;

                }
                catch (Exception)
                {
                    closeConnection();
                    this.sb_status.Text = "Error while sending LoggerRequest";
                }
            }
            catch (Exception)
            {
                closeConnection();
                this.sb_status.Text = "Error while connecting!";
            }
        }
        //--------------------------------------------------------------------------------------------


        private void callback_receive(IAsyncResult ar)
        {

            int receiveCount = 0;

            try
            {
                if (TCP_Client != null)
                {
                    if (TCP_Client.Connected)
                    {
                        receiveCount = TCP_Client.EndReceive(ar);
                        Array.Copy(receiveBuffer, this.lastReceive, 511);
                        Array.Clear(receiveBuffer, 0, 512);
                        this.Invoke(new Delegatevoid(evaluateResponse));
                        TCP_Client.BeginReceive(receiveBuffer, 0, 72, SocketFlags.None, new AsyncCallback(callback_receive), TCP_Client);
                    }
                }
            }
            catch (Exception)
            {
                closeConnection();
                this.sb_status.Text = "Error while receiving!";
            }

            if (receiveCount == 0)
            {
                closeConnection();
            }

        }
        //--------------------------------------------------------------------------------------------


        private void closeConnection()
        {

            try
            {
                if (TCP_Client != null)
                {
                    if (TCP_Client.Connected)
                    {
                        TCP_Client.Shutdown(SocketShutdown.Both);
                        TCP_Client.Close();
                        TCP_Client = null;
                    }
                }

                this.sb_status.Text = "no connection";

                this.Invoke(new Delegatevoid(connectenable));
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while disconnecting!";
            }

        }
        //--------------------------------------------------------------------------------------------


        private void connectdisable()
        {

            this.bt_connect.Enabled = false;

        }
        //--------------------------------------------------------------------------------------------


        private void connectenable()
        {

            this.bt_connect.Enabled = true;

        }
        //--------------------------------------------------------------------------------------------


        private void evaluateResponse()
        {

            structs.LoggerDataRequest LoggerDataRequest = new structs.LoggerDataRequest();
            Timer1.Enabled = false;

            switch (BitConverter.ToInt16(this.lastReceive, 4))
            {
                case 0x1E1:
                    structs.LoggerCheck LoggerCheck = (structs.LoggerCheck)ByteConvert.ToStruct(this.lastReceive, typeof(structs.LoggerCheck));

                    lw_receive.Items.Add("-> receive LoggerCheck");
                    lw_receive.Items.Add("LoggerState=" + LoggerCheck.LoggerState);
                    lw_receive.Items.Add("MemorySize=" + LoggerCheck.MemorySize);
                    lw_receive.Items.Add("MemoryProgress=" + LoggerCheck.MemoryProgress);

                    if( LoggerCheck.LoggerState != 4 )
                    {
                        lw_receive.Items.Add("");
                        lw_receive.Items.Add("<- send LoggerCheck");
                        this.sb_status.Text = "Checking Logger Memory";

                        if( LoggerCheck.LoggerState > 2 )
                        {
                            this.ProgressBar1.Maximum = (int)LoggerCheck.MemorySize;
                            this.ProgressBar1.Value = (int)LoggerCheck.MemoryProgress;
                        }

                        byte[] cmd = ByteConvert.ToBytes(LoggerCheck, typeof(structs.LoggerCheck));
                        this.TCP_Client.Send(cmd, cmd.Length, SocketFlags.None);
                    }else{
                        LoggerDataRequest.Start_1 = 0;
                        LoggerDataRequest.Start_2 = 0;
                        LoggerDataRequest.StructType = 0x1E2;
                        LoggerDataRequest.StructLength = 8;


                        byte[] cmd = ByteConvert.ToBytes(LoggerDataRequest, typeof(structs.LoggerDataRequest));
                        this.TCP_Client.Send(cmd, cmd.Length, SocketFlags.None);

                        lw_receive.Items.Add("");
                        lw_receive.Items.Add("<- send LoggerDataRequest");
                    }
                    break;
                case 0x1E2:
                    structs.LoggerDataSet LoggerDataSet = (structs.LoggerDataSet)ByteConvert.ToStruct(this.lastReceive, typeof(structs.LoggerDataSet));

                    this.sb_status.Text = "Loading Datasets from Logger";

                    this.ProgressBar1.Maximum = (int)LoggerDataSet.MaxCount;
                    this.ProgressBar1.Value = (int)LoggerDataSet.ProcessCount;


                    lw_receive.Items.Add("-> receive LoggerDataSet");
                    lw_receive.Items.Add("MaxCount=" + LoggerDataSet.MaxCount);
                    lw_receive.Items.Add("ProcessCount=" + LoggerDataSet.ProcessCount);


                    TimeSpan offset = new TimeSpan(0, 0, 0, (int)LoggerDataSet.TimeSecs + 3600 * int.Parse(ed_utcoffset.Text), 0);
                    lw_receive.Items.Add("Time=" + baseDate.Add(offset).ToString());


                    lw_receive.Items.Add("TimeMSecs=" + LoggerDataSet.TimeMSecs);
                    lw_receive.Items.Add("InputState=" + LoggerDataSet.InputState.ToString("X"));
                    lw_receive.Items.Add("OutputState=" + LoggerDataSet.OutputState.ToString("X"));
                    lw_receive.Items.Add("Alarms=" + LoggerDataSet.Alarms.ToString("X"));
                    lw_receive.Items.Add("CounterValue0=" + LoggerDataSet.CounterValue[0]);
                    lw_receive.Items.Add("CounterValue1=" + LoggerDataSet.CounterValue[1]);
                    lw_receive.Items.Add("CounterValue2=" + LoggerDataSet.CounterValue[2]);
                    lw_receive.Items.Add("CounterValue3=" + LoggerDataSet.CounterValue[3]);
                    lw_receive.Items.Add("CounterValue4=" + LoggerDataSet.CounterValue[4]);
                    lw_receive.Items.Add("CounterValue5=" + LoggerDataSet.CounterValue[5]);

                    lw_receive.Items.Add("ErrorCounter0=" + LoggerDataSet.CounterValue[0]);
                    lw_receive.Items.Add("ErrorCounter1=" + LoggerDataSet.CounterValue[1]);
                    lw_receive.Items.Add("ErrorCounter2=" + LoggerDataSet.CounterValue[2]);

                    break;
                case 0x1E3:
                    structs.LoggerNoAccess LoggerNoAccess = (structs.LoggerNoAccess)ByteConvert.ToStruct(this.lastReceive, typeof(structs.LoggerNoAccess));

                    this.sb_status.Text = "Access Denied";
                    lw_receive.Items.Add("-> receive LoggerNoAccess");
                    lw_receive.Items.Add("LoggerState=" + LoggerNoAccess.LoggerState);

                    break;
            }
            lw_receive.Items.Add("");
            lw_receive.Items[lw_receive.Items.Count - 1].EnsureVisible();
            Timer1.Enabled = true;

        }
        //--------------------------------------------------------------------------------------------


        private void Form1_Load(object sender, EventArgs e)
        {
            this.ed_year0.Text = DateTime.Now.Year.ToString();
            this.ed_month0.Text = DateTime.Now.Month.ToString();
            this.ed_year1.Text = DateTime.Now.Year.ToString();
            this.ed_month1.Text = DateTime.Now.Month.ToString();
            this.ed_day1.Text = DateTime.Now.Day.ToString();
            this.ed_hour1.Text = DateTime.Now.Hour.ToString();
            this.ed_minute1.Text = DateTime.Now.Minute.ToString();
            this.ed_second1.Text = DateTime.Now.Second.ToString();

            this.lw_receive.Columns.Add("Received Data", this.lw_receive.Width - 10, HorizontalAlignment.Left);
        }
        //--------------------------------------------------------------------------------------------


        private void Timer1_Tick(object sender, EventArgs e)
        {
            this.Timer1.Enabled = false;
            this.ProgressBar1.Value = this.ProgressBar1.Maximum;
            this.sb_status.Text = "Timeout - Connection closed";
            bt_connect.Enabled = true;
            closeConnection();
        }
        //--------------------------------------------------------------------------------------------

    }
}
