﻿using System;
using System.Runtime.InteropServices;

namespace cs41_webio_logger
{
    namespace structs
    {


        [StructLayout(LayoutKind.Sequential)]
        public class LoggerRequest
        {
            public UInt16 Start_1;
            public UInt16 Start_2;
            public UInt16 StructType;
            public UInt16 StructLength;

            public UInt32 StartSecs;
            public UInt32 StopSecs;
            public UInt16 StartMSecs;
            public UInt16 StopMSecs;
        }

        [StructLayout(LayoutKind.Sequential)]
        public class LoggerNoAccess
        {
            public UInt16 Start_1;
            public UInt16 Start_2;
            public UInt16 StructType;
            public UInt16 StructLength;

            public UInt32 LoggerState;
        }

        [StructLayout(LayoutKind.Explicit)]
        public class LoggerCheck
        {
            [FieldOffset(0)]
            public UInt16 Start_1;
            [FieldOffset(2)]
            public UInt16 Start_2;
            [FieldOffset(4)]
            public UInt16 StructType;
            [FieldOffset(6)]
            public UInt16 StructLength;

            [FieldOffset(8)]
            public UInt32 LoggerState;
            [FieldOffset(12)]
            public UInt32 MemorySize;
            [FieldOffset(16)]
            public UInt32 MemoryProgress;
        }

        [StructLayout(LayoutKind.Sequential)]
        public class LoggerDataRequest
        {
            public UInt16 Start_1;
            public UInt16 Start_2;
            public UInt16 StructType;
            public UInt16 StructLength;
        }

        [StructLayout(LayoutKind.Explicit)]
        public class LoggerDataSet
        {
            [FieldOffset(0)] public UInt16 Start_1;
            [FieldOffset(2)] public UInt16 Start_2;
            [FieldOffset(4)] public UInt16 StructType;
            [FieldOffset(6)] public UInt16 StructLength;
            [FieldOffset(8)] public UInt32 MaxCount;
            [FieldOffset(12)] public UInt32 ProcessCount;
            [FieldOffset(16)] public UInt32 TimeSecs;
            [FieldOffset(20)] public UInt32 TimeMSecs;
            [FieldOffset(24)] public UInt16 OutputState;
            [FieldOffset(26)] public UInt16 InputState;
            [FieldOffset(28)] public UInt32 Reserved;
            [FieldOffset(32)] public UInt32 Alarms;

            [FieldOffset(36)]
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
            public UInt32[] CounterValue;

            [FieldOffset(60)]
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 3)]
            public UInt32[] CounterError;
        }



    }
}